#include "pde_struct2.h"

void PDE_STRUCT2::allocate(vct &ibas, int iMAX_ORDER, symbol &it, symbol &ix, symbol &iy, symbol &iz)
{
	bas=ibas;
	MO=iMAX_ORDER;
	Nbas=bas.size();
	t=it;
	x=ix;
	y=iy;
	z=iz;
	zero_ders.remove_all();
	MOindex = (MO+1)*(MO+1)*(MO+1)*(MO+1)*Nbas;

	// 2D data
	data2D0 = new ex*[MOindex];
	for (int i=0;i<MOindex;i++) data2D0[i] = new ex[MOindex];
	data2D1 = new ex*[MOindex];
	for (int i=0;i<MOindex;i++) data2D1[i] = new ex[MOindex];
	data2D=data2D0;
	prev2D=data2D1;
	for (int i=0;i<MOindex;i++)
	for (int j=0;j<MOindex;j++)
	{
		data2D0[i][j] = 0;
		data2D1[i][j] = 0;
	}
	// 1D data
	data1D0 = new ex[MOindex];
	data1D1 = new ex[MOindex];
	for (int j=0;j<MOindex;j++)
	{
		data1D0[j] = 0;
		data1D1[j] = 0;
	}
	data1D=data1D0;
	prev1D=data1D1;
	// 0D data
	data0D = 0;

	basders = new ex[MOindex];
	for (int i=0;i<MOindex;i++) basders[i] = 0;

	for (int bi=0;bi<Nbas;bi++)
	for (int o=0;o<=MO;o++) for (int i0=0;i0<=o;i0++) for (int i1=0;i1<=o;i1++) for (int i2=0;i2<=o;i2++) for (int i3=0;i3<=o;i3++) if (i0+i1+i2+i3==o)
		basders[ind(bi,i0,i1,i2,i3)] = GiNaC::diff(GiNaC::diff(GiNaC::diff(GiNaC::diff( bas[bi], t, i0 ), x, i1), y, i2), z, i3);

	for (int bi=0;bi<Nbas;bi++)
	for (int o=1;o<=MO;o++) for (int i0=0;i0<=o;i0++) for (int i1=0;i1<=o;i1++) for (int i2=0;i2<=o;i2++) for (int i3=0;i3<=o;i3++) if (i0+i1+i2+i3==o)
	{
		zero_ders.append( basders[ind(bi,i0,i1,i2,i3)] == 0 );
		zero_ders.append( pow( basders[ind(bi,i0,i1,i2,i3)], 2) == 0 );
	}

	for (int bi=0;bi<Nbas;bi++)
	for (int o=MO+1;o<=MO+1;o++)
	for (int i0=0;i0<=o;i0++)
	for (int i1=0;i1<=o;i1++)
	for (int i2=0;i2<=o;i2++)
	for (int i3=0;i3<=o;i3++)
	if (i0+i1+i2+i3==o)
	{
		zero_ders.append( GiNaC::diff(GiNaC::diff(GiNaC::diff(GiNaC::diff( bas[bi], t, i0 ), x, i1), y, i2), z, i3) == 0);
		zero_ders.append( pow (GiNaC::diff(GiNaC::diff(GiNaC::diff(GiNaC::diff( bas[bi], t, i0 ), x, i1), y, i2), z, i3), 2) == 0);
	}
}

void PDE_STRUCT2::eat(ex expression)
{
	if (expression==0) return;

	ex rest=GiNaC::expand(expression);
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	{
		// treat squares
		ex co;
		co=GiNaC::coeff( rest, basders[ind(bi,i0,i1,i2,i3)], 2 );
		if (co!=0)
		{
			rest = GiNaC::expand(rest - co*pow(basders[ind(bi,i0,i1,i2,i3)],2) );
			if (2*oi<=max_factors_common_order) // trim higher derivatives
				data(bi,i0,i1,i2,i3, bi,i0,i1,i2,i3) += GiNaC::expand( subs( GiNaC::expand(co), zero_ders ));
		}

		co=GiNaC::coeff( rest, basders[ind(bi,i0,i1,i2,i3)] );
		if (co!=0)
		{
			rest = GiNaC::expand(rest - co*basders[ind(bi,i0,i1,i2,i3)] );
			// now decompose co into basders again
			for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
			for (int bj=0;bj<Nbas;bj++)
			{
				ex co2=GiNaC::coeff( co, basders[ind(bj,j0,j1,j2,j3)] );
				if (co2!=0)
				{
					co = GiNaC::expand(co - co2*basders[ind(bj,j0,j1,j2,j3)] );
					if (oi+oj<=max_factors_common_order) // trim higher derivatives
						data_w( bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) += GiNaC::expand( subs( GiNaC::expand(co2), zero_ders ));
				}
			}
			if (co!=0)
				data( bi,i0,i1,i2,i3 ) += GiNaC::expand( subs( GiNaC::expand(co), zero_ders ));
		}
	}
	if (rest!=0) data0D += GiNaC::expand( subs( GiNaC::expand( rest ), zero_ders ));
}

void PDE_STRUCT2::print(ostringstream &out)
{
	ostringstream sout;
	// 0D
	if (data0D!=0)
	{
		sout << "1" << endl;
		sout << "...." << data0D << endl;
	}
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	if (data( bi,i0,i1,i2,i3 )!=0)
	{
		sout << basders[ind(bi,i0,i1,i2,i3)] << endl;
		sout << "...." << data( bi,i0,i1,i2,i3 ) <<endl;
	}

	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
	if (data( bi,i0,i1,i2,i3, bj,j0,j1,j2,j3 )!=0)
	{
		sout << basders[ind(bi,i0,i1,i2,i3)] << "  *  " << basders[ind(bj,j0,j1,j2,j3)] << endl;
		sout << "...." << data( bi,i0,i1,i2,i3, bj,j0,j1,j2,j3 ) <<endl;
	}

	string str1 = sout.str();
	str1 = ReplaceString( str1, "(t,x,y,z)", "");
	str1 = ReplaceString( str1, "fu", "u");
	str1 = ReplaceString( str1, "fv", "v");
	str1 = ReplaceString( str1, "fw", "w");
	str1 = ReplaceString( str1, "frho", "rho");
	out << str1;
}

void PDE_STRUCT2::copy(PDE_STRUCT2 &A)
{
	free();
	allocate(A.bas,A.MO,A.t,A.x,A.y,A.z);
	max_factors_common_order = A.max_factors_common_order;
	for (int i=0;i<MOindex;i++)
	{
		for (int j=0;j<MOindex;j++)
		{
			data2D0[i][j] = A.data2D0[i][j];
			data2D1[i][j] = A.data2D1[i][j];
		}
		data1D0[i] = A.data1D0[i];
		data1D1[i] = A.data1D1[i];
	}
	data2D = (A.data2D==A.data2D0) ? data2D0 : data2D1;
	prev2D = (A.prev2D==A.data2D0) ? data2D0 : data2D1;
	data1D = (A.data1D==A.data1D0) ? data1D0 : data1D1;
	prev1D = (A.prev1D==A.data1D0) ? data1D0 : data1D1;
	data0D = A.data0D;
}

void PDE_STRUCT2::empty(ex **d)
{
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
		d[ind(bi,i0,i1,i2,i3)][ind(bj,j0,j1,j2,j3)]=0;
}

void PDE_STRUCT2::empty(ex *d)
{
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		d[ind(bi,i0,i1,i2,i3)]=0;
}

void PDE_STRUCT2::diff_worker(int i)
{
	symbol dd=t;
	int d0=1,d1=0,d2=0,d3=0;
	switch (i)
	{
		case 1: dd=x; d0=0; d1=1; d2=0; d3=0; break; // x
		case 2: dd=y; d0=0; d1=0; d2=1; d3=0; break; // y
		case 3: dd=z; d0=0; d1=0; d2=0; d3=1; break; // z
	}

	swap();
	ex prev0D=data0D;
	empty(data2D);
	empty(data1D);
	data0D=0;
	// diff 0D
	if (prev0D!=0) eat( GiNaC::expand( GiNaC::diff( prev0D, dd ) ) );

	// diff 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	{
		ex cA=prev(bi,i0,i1,i2,i3);
		// differentiation of a product  D(cA * dA) = D(cA) dA + cA * D(dA)
		if (cA!=0)
		{
			cA = GiNaC::expand( cA );
			// cA * D(dA)
			if (oi<MO) data(bi,i0+d0,i1+d1,i2+d2,i3+d3) += cA;
			// D(cA) * dA
			cA = GiNaC::expand( GiNaC::diff( cA, dd) );
			if (cA!=0 && oi+1<= max_factors_common_order) // trim higher derivatives
			{
				for (int bk=0;bk<Nbas;bk++)
				{
					ex co2 = GiNaC::coeff( cA, basders[ind(bk,d0,d1,d2,d3)] );
					if (co2!=0) data_w( bi,i0,i1,i2,i3, bk,d0,d1,d2,d3 ) += GiNaC::expand( subs( GiNaC::expand(co2), zero_ders ));
				}
			}
		}
	}

	// diff 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
	{
		//  D( coef * dA * dB ) =  coef * [ D(dA)*dB + dA*D(dB) ]_{case1} + [ D(coef) * dA*dB ]_{case2}
		//  case 1a
		if (ind(bi,i0,i1,i2,i3) == ind(bj,j0,j1,j2,j3)) // diagonal term D( dA^2 ) = 2 dA D(dA)
		{
			if (oi<MO && 2*oi+1 <= max_factors_common_order)
				data_w( bi,i0+d0,i1+d1,i2+d2,i3+d3, bj,j0,j1,j2,j3) += (ex)2*prev(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3);
		} else
		{
			if (oi<MO && oi+1+oj<= max_factors_common_order)
				data_w(bi,i0+d0,i1+d1,i2+d2,i3+d3, bj,j0,j1,j2,j3) += prev(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3);
			if (oj<MO && oi+oj+1<= max_factors_common_order)
				data_w(bi,i0,i1,i2,i3,  bj,j0+d0,j1+d1,j2+d2,j3+d3) += prev(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3);
		}
	}
}

void PDE_STRUCT2::diff(int i, int order)
{
	if (order<=0) return;
	for (int j=0;j<order;j++) diff_worker(i);
}

bool PDE_STRUCT2::get_der_index(ex der, int &bi, int &i0, int &i1, int &i2, int &i3)
{
	bi=0;i0=0;i1=0;i2=0;i3=0;
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bj=0;bj<Nbas;bj++)
	if ( basders[ind(bj,j0,j1,j2,j3)] == der )
	{
		bi=bj;i0=j0;i1=j1;i2=j2;i3=j3;
		return true;
	}
	return false;
}

void PDE_STRUCT2::mul(ex e)
{
	// 0D
	data0D *= e;
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	if (data(bi,i0,i1,i2,i3)!=0)
		data(bi,i0,i1,i2,i3) *= e;
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
	if (data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3)!=0)
		data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) *= e;
}

void PDE_STRUCT2::add(PDE_STRUCT2 &A)
{
	if (MO != A.MO || Nbas != A.Nbas) 
	{
		cout << "ERROR: PDE_STRUCT2::add() incompatible structures in addition"<<endl;
		return;
	}
	// 0D
	data0D += A.data0D;
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		data(bi,i0,i1,i2,i3) += A.data(bi,i0,i1,i2,i3);
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
		data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) += A.data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3);
}


void PDE_STRUCT2::expand()
{
	// 0D
	data0D = GiNaC::expand( data0D );
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		data(bi,i0,i1,i2,i3) = GiNaC::expand( data(bi,i0,i1,i2,i3) );
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
		data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) = GiNaC::expand( data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) );
}

void PDE_STRUCT2::normal()
{
	// 0D
	data0D = GiNaC::expand( GiNaC::normal( data0D ));
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		data(bi,i0,i1,i2,i3) = GiNaC::expand( GiNaC::normal( data(bi,i0,i1,i2,i3) ));
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
		data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) = GiNaC::expand( GiNaC::normal( data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) ));
}

bool PDE_STRUCT2::compare(PDE_STRUCT2 &A)
{
	if (Nbas != A.Nbas || MO != A.MO) return false;

	// 0D
	if (data0D != A.data0D) return false;
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		if (data(bi,i0,i1,i2,i3) != A.data(bi,i0,i1,i2,i3) ) return false;
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
		if (data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) != A.data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) ) return false;

	return true; // the same
}

bool PDE_STRUCT2::is_empty()
{
	// 0D
	if (data0D!=0) return false;
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		if (data(bi,i0,i1,i2,i3)!=0) return false;
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
		if (data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3)!=0) return false;
	return true;
}


ex PDE_STRUCT2::raw()
{
	// 0D
	ex result=data0D;
	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	if (data(bi,i0,i1,i2,i3)!=0)
		result += data(bi,i0,i1,i2,i3)*basders[ind(bi,i0,i1,i2,i3)];
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
	if (data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3)!=0)
		result += data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3)*basders[ind(bi,i0,i1,i2,i3)]*basders[ind(bj,j0,j1,j2,j3)];
	return result;
}

void PDE_STRUCT2::save(const char* dirname, const char* subdirname, const char*fmt, ... )
{
	char name[1024];
	va_list args;
	va_start(args, fmt);
	vsprintf(name, fmt, args);
	va_end(args);

	char fn[1000], dn[1000];
	mkdir(dirname,0777);
	sprintf(dn,"%s/%s",dirname,subdirname);
	mkdir(dn,0777);
	sprintf(dn,"%s/%s/%s",dirname,subdirname,name);
	mkdir(dn,0777);

	// 0D
	if (data0D!=0)
	{
		stringstream sfn;
		sfn << dn << "/coef_1";
		ofstream fout(sfn.str());
		fout << data0D <<endl;
		fout.close();
	}

	// 1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	if (data(bi,i0,i1,i2,i3)!=0)
	{
		stringstream sfn;
		sfn << dn << "/coef_" << bas[bi] << "_";
		for (int j=0;j<i0;j++) sfn << "t";
		for (int j=0;j<i1;j++) sfn << "x";
		for (int j=0;j<i2;j++) sfn << "y";
		for (int j=0;j<i3;j++) sfn << "z";
		ofstream fout(sfn.str());
		fout << data(bi,i0,i1,i2,i3)<<endl;
		fout.close();
	}
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
	if (data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3)!=0)
	{
		stringstream sfn;
		sfn << dn << "/coef_" << bas[bi] << "_";
		for (int j=0;j<i0;j++) sfn << "t";
		for (int j=0;j<i1;j++) sfn << "x";
		for (int j=0;j<i2;j++) sfn << "y";
		for (int j=0;j<i3;j++) sfn << "z";
		sfn << "__X__" << bas[bj] << "_";
		for (int j=0;j<j0;j++) sfn << "t";
		for (int j=0;j<j1;j++) sfn << "x";
		for (int j=0;j<j2;j++) sfn << "y";
		for (int j=0;j<j3;j++) sfn << "z";
		ofstream fout(sfn.str());
		fout << data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3)<<endl;
		fout.close();
	}
	// raw output
	ostringstream sout;
	print(sout);
	sprintf(fn,"%s/%s/%s_output_raw_pde",dirname,subdirname,name);
	ofstream fout(fn);
	fout << raw() << endl<<endl;
	fout << sout.str() << endl;
	fout.close();
}

string PDE_STRUCT2::derivative_tex(int bj, int j0, int j1, int j2, int j3)
{
	ostringstream s;
	s<<latex;
	int o=j0+j1+j2+j3;
	if (o!=0)
	{
		if (o==1)
			s << "\\frac{ \\partial "<< bas[bj] << "}";
		else
			s << "\\frac{ \\partial^"<< o <<" "<< bas[bj] << "}";
		s << "{";
		if (j0>0) { if (j0==1) s << "\\partial t"; else s << "\\partial t^{"<<j0<<"}"; }
		if (j1>0) { if (j1==1) s << "\\partial x"; else s << "\\partial x^{"<<j1<<"}"; }
		if (j2>0) { if (j2==1) s << "\\partial y"; else s << "\\partial y^{"<<j2<<"}"; }
		if (j3>0) { if (j3==1) s << "\\partial z"; else s << "\\partial z^{"<<j3<<"}"; }
		s << "}";
	}
	return ReplaceString( s.str(), "(t,x,y,z)", "");
}

void PDE_STRUCT2::save_tex(const char* dirname, const char* subdirname, const char*fmt, ... )
{
	char name[1024];
	va_list args;
	va_start(args, fmt);
	vsprintf(name, fmt, args);
	va_end(args);

	char fn[1000], dn[1000];
	mkdir(dirname,0777);
	sprintf(dn,"%s/%s",dirname,subdirname);
	mkdir(dn,0777);

	sprintf(fn,"%s/%s/%s.tex",dirname,subdirname,name);
	ofstream fout(fn);
	fout << latex;
	// header
	fout<< "\\begin{flushleft}" << endl;
	fout<< "\\noindent\n$\n";

	bool first=true;
	for (int ok=1;ok<=2*MO;ok++)
	for (int oi=1;oi<=MO;oi++)  for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) for (int i0=0;i0<=oi;i0++) if (i0+i1+i2+i3==oi)
	{
		// 1D terms
		if (oi==ok)
		for (int bi=0;bi<Nbas;bi++)
		{
			ex co = data(bi,i0,i1,i2,i3);
			if (co!=0)
			{
				if (first) first=false; else fout << "+" << endl;
				if (co!=1) fout << factorize_latex(co) << endl;
				fout << "{\\color{blue}"<< derivative_tex(bi, i0, i1, i2, i3) << "}"<<endl;
			}
		}

		// 2D terms
		for (int oj=1;oj<=MO;oj++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) for (int j0=0;j0<=oj;j0++) if (j0+j1+j2+j3==oj)
		if (oi+oj==ok)
		for (int bj=0;bj<Nbas;bj++)
		for (int bi=0;bi<Nbas;bi++)
		{
			ex co = data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3);
			if (co!=0)
			{
				if (first) first=false; else fout << "+" << endl;
				if (co!=1) fout << factorize_latex(co) << endl;
				if (ind(bi,i0,i1,i2,i3)==ind(bj,j0,j1,j2,j3))
					fout << "\\left({\\color{blue}"<<derivative_tex(bj, j0, j1, j2, j3)<< "}\\right)^2"<<endl;
				else
					fout << "{\\color{blue}"<< derivative_tex(bi, i0, i1, i2, i3) << " "<< derivative_tex(bj, j0, j1, j2, j3)<< "}"<<endl;
			}
		}
	}
	if (data0D!=0)
		fout << "= " << factorize_latex(-data0D) <<endl;
	 else
	 	fout << "=0";
	fout<< ".$\n\\end{flushleft}" << endl;
	fout.close();
}

bool PDE_STRUCT2::nonzero_coeff(int bk, int k0, int k1, int k2, int k3)
{
	// 1D
	if (data(bk,k0,k1,k2,k3)!=0) return true;
	// 2D
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bj=0;bj<Nbas;bj++)
	{
		if (ind(bk,k0,k1,k2,k3)<=ind(bj,j0,j1,j2,j3))
		if (data(bk,k0,k1,k2,k3, bj,j0,j1,j2,j3)!=0)
			return true;

		if (ind(bj,j0,j1,j2,j3)<=ind(bk,k0,k1,k2,k3))
		if (data(bj,j0,j1,j2,j3, bk,k0,k1,k2,k3)!=0)
			return true;
	}
	return false;
}


bool PDE_STRUCT2::replace_der_by_expr(int bk, int kt, int kx, int ky, int kz, PDE_STRUCT2 &subsexpr)
{
	bool replaced_at_least_one=false;
	// case 1: check quadradic term
	ex c00 = data(bk,kt,kx,ky,kz, bk,kt,kx,ky,kz);
	if (c00!=0)
	{
		PDE_STRUCT2 A;
		data(bk,kt,kx,ky,kz, bk,kt,kx,ky,kz) = 0;
		A.copy(subsexpr);
		A.mul(subsexpr); 	// A = loc_se^2
		A.mul(c00);		// A = c00 loc_se^2
		add(A);			// add A to this
		replaced_at_least_one=true;
	}
	// case 2: check the remaining terms
	// create B === coefs by basders[ind(bi,kt,kx,ky,kz)] without the quadratic term above
	PDE_STRUCT2 B;
	B.allocate(bas, MO, t, x, y, z); // copy of "this"
	// now select only entries that correspond to basders[ind(bk,kt,kx,ky,kz)] ... without the quadratic term obviously
	// 1D
	B.data0D = data(bk,kt,kx,ky,kz);
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	if (ind(bi,i0,i1,i2,i3) != ind(bk,kt,kx,ky,kz)) // this is not necessary, the quadratic term is zero anyway
		B.data(bi,i0,i1,i2,i3) = data(bi,i0,i1,i2,i3, bk,kt,kx,ky,kz) + data(bk,kt,kx,ky,kz, bi,i0,i1,i2,i3);
	// now zero these term in "this"
	// 1D
	data(bk,kt,kx,ky,kz) = 0;
	// 2D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
	{
		//if (data(bi,i0,i1,i2,i3, bk,kt,kx,ky,kz)!=0)
		data(bi,i0,i1,i2,i3, bk,kt,kx,ky,kz) = 0;
		//if (data(bk,kt,kx,ky,kz, bi,i0,i1,i2,i3)!=0)
		data(bk,kt,kx,ky,kz, bi,i0,i1,i2,i3) = 0;
	}

	if (!B.is_empty())
	{
		B.mul(subsexpr);
		// now add the result in "this"
		add(B);
		replaced_at_least_one=true;
	}

	return replaced_at_least_one;
}


void PDE_STRUCT2::mul(PDE_STRUCT2 &A)
{
	// A = C0 + sum_k Ck dk + sum_k sum_l Ckl dk dl
	// B = D0 + sum_k Dk dk + sum_k sum_l Dkl dk dl
	// with C0=0=D0 !!!
	// so, A*B = sum_k sum_l Ck Dl dk dl only ;-)
	// so in multiplication, only Ck dk coefficients will be there because of truncation !!!
	swap();
	empty(data2D);
	empty(data1D);
	ex prev0D = data0D;

	// 0D * A.0D:
	data0D = prev0D*A.data0D;
	// 0D * A.1D + 1D * A.0D:
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int bi=0;bi<Nbas;bi++)
		data(bi,i0,i1,i2,i3) = prev0D * A.data(bi,i0,i1,i2,i3) + prev(bi,i0,i1,i2,i3) * A.data0D;

	// 0D * A.2D + 2D * A.0D:
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (ind(bi,i0,i1,i2,i3)<=ind(bj,j0,j1,j2,j3))
	if (oi+oj<=max_factors_common_order)
		data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) = prev0D * A.data(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) + prev(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) * A.data0D;

	// 1D * A.1D
	for (int oi=1;oi<=MO;oi++) for (int i0=0;i0<=oi;i0++) for (int i1=0;i1<=oi;i1++) for (int i2=0;i2<=oi;i2++) for (int i3=0;i3<=oi;i3++) if (i0+i1+i2+i3==oi)
	for (int oj=1;oj<=MO;oj++) for (int j0=0;j0<=oj;j0++) for (int j1=0;j1<=oj;j1++) for (int j2=0;j2<=oj;j2++) for (int j3=0;j3<=oj;j3++) if (j0+j1+j2+j3==oj)
	for (int bi=0;bi<Nbas;bi++)
	for (int bj=0;bj<Nbas;bj++)
	if (oi+oj<=max_factors_common_order)
		data_w(bi,i0,i1,i2,i3, bj,j0,j1,j2,j3) += prev(bi,i0,i1,i2,i3) * A.data(bj,j0,j1,j2,j3);
}

void PDE_STRUCT2::swap()
{
	data2D = (data2D==data2D1) ? data2D0 : data2D1;
	prev2D = (prev2D==data2D1) ? data2D0 : data2D1;
	data1D = (data1D==data1D1) ? data1D0 : data1D1;
	prev1D = (prev1D==data1D1) ? data1D0 : data1D1;
}

void PDE_STRUCT2::free()
{
	if (data2D0)
	{
		for (int i=0;i<MOindex;i++) delete [] data2D0[i];
		delete [] data2D0;
	}
	if (data2D1)
	{
		for (int i=0;i<MOindex;i++) delete [] data2D1[i];
		delete [] data2D1;
	}
	if (data1D0) delete [] data1D0;
	if (data1D1) delete [] data1D1;
	if (basders) delete [] basders;
	zero_ders.remove_all();
}
