#include "taylor.h"

void TAYLOR::allocate(const char*comp, ex central_value)
{
	char desc[1000], desc_tex[1000], s[20], s1[50],s2[50],s3[50],s4[50],s5[50],s6[50];
	central = central_value;
	// allocaate sub
	sub = new ex[Nindex];

	// allocate tay
	tay = new symbol[(ORDER+1)*(ORDER+1)*(ORDER+1)*(ORDER+1)];

	pow_dl = new int[(ORDER+1)*(ORDER+1)*(ORDER+1)*(ORDER+1)];
	pow_dt = new int[(ORDER+1)*(ORDER+1)*(ORDER+1)*(ORDER+1)];
	for (int k1=0;k1<=ORDER;k1++)
	for (int k2=0;k2<=ORDER;k2++)
	for (int k3=0;k3<=ORDER;k3++)
	for (int k4=0;k4<=ORDER;k4++)
	{
		int k=k1+k2+k3+k4;
		int kx=k2+k3+k4;
		pow_dt[indO(k1,k2,k3,k4)]=k1;
		pow_dl[indO(k1,k2,k3,k4)]=kx;

		sprintf(s5,""); // prefix
		sprintf(s6,""); // suffix

		if (k1>0) { sprintf(s5,"%sdiff(",s5); sprintf(s6,"%s, t, %d)",s6, k1);}
		if (k2>0) { sprintf(s5,"%sdiff(",s5); sprintf(s6,"%s, x, %d)",s6, k2);}
		if (k3>0) { sprintf(s5,"%sdiff(",s5); sprintf(s6,"%s, y, %d)",s6, k3);}
		if (k4>0) { sprintf(s5,"%sdiff(",s5); sprintf(s6,"%s, z, %d)",s6, k4);}

		sprintf(desc,"%s%s(t,x,y,z)%s",s5,comp,s6);

		// tay tex
		sprintf(s1,""); for (int ik=0;ik<k1;ik++) sprintf(s1,"%st",s1);
		sprintf(s2,""); for (int ik=0;ik<k2;ik++) sprintf(s2,"%sx",s2);
		sprintf(s3,""); for (int ik=0;ik<k3;ik++) sprintf(s3,"%sy",s3);
		sprintf(s4,""); for (int ik=0;ik<k4;ik++) sprintf(s4,"%sz",s4);
		if (k==0)
			sprintf(desc_tex,"{%s}",comp);
		else
		if (k==1)
			sprintf(desc_tex,"{\\partial_{%s%s%s%s}%s}",s1,s2,s3,s4,comp);
		else
			sprintf(desc_tex,"{\\partial^{%d}_{%s%s%s%s}%s}",k,s1,s2,s3,s4,comp);
		tay[indO(k1,k2,k3,k4)] = symbol(desc, desc_tex);
	}
	taylor_expand();
}

void TAYLOR::taylor_expand()
{
	for (int l=0;l<L;l++)
	for (int z=-(l+1);(z<=l+1 && DIM==3) || (z<=-(l+1));z++)
	for (int y=-(l+1);(y<=l+1 && DIM>=2) || (y<=-(l+1));y++)
	for (int x=-(l+1);x<=l+1;x++)
	if (isin(l,x,y,z))
	{
		// use Taylor expansion here
		if (central!=0)
			sub[index(l,x,y,z)] = central;
		else
			sub[index(l,x,y,z)] = tay[indO(0,0,0,0)];

		for (int k=1;k<=ORDER;k++)
		for (int j=0;j<=k;j++)
		for (int j3=0;(j3<=k && DIM==3) || (j3<=0);j3++)
		for (int j2=0;(j2<=k && DIM>=2) || (j2<=0);j2++)
		for (int j1=0;j1<=k;j1++)
		if (j1+j2+j3==j)
		{
			ex koef=(ex)1;
			if (k-j>0) koef*=pow((ex)l*dt,k-j);
			if (j1>0) koef*=pow((ex)x*dl,j1);
			if (j2>0) koef*=pow((ex)y*dl,j2);
			if (j3>0) koef*=pow((ex)z*dl,j3);

			sub[index(l,x,y,z)] += koef*tay[indO(k-j,j1,j2,j3)]/factorial(k-j)/factorial(j1)/factorial(j2)/factorial(j3);
		}
	}
}
